import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import javax.imageio.*;
import java.io.*;
public class ImagePreviewPanel extends JPanel{
	BufferedImage bi;
	ImagePreviewPanel(){
		setPreferredSize(new Dimension(400,300));
	}
	public void setImage(File f){
		try{
			bi = ImageIO.read(f);
		}catch(Exception exx){
			exx.printStackTrace();
			bi = null;
		}
		repaint();
	}
	
	public void paint(Graphics g){
		int w = this.getWidth();
		int h = this.getHeight();
		if(bi != null){
			int iw = bi.getWidth();
			int ih = bi.getHeight();
			int bw = bi.getWidth();
			int bh = bi.getHeight();
			
			if(iw > w || ih > h){
				double ratio = 1.0;
				if(w/(double)iw > h/(double)ih){
					ratio = h/(double)ih;
				}else{
					ratio = w/(double)iw;
				}
				bw = (int)(ratio*iw);
				bh = (int)(ratio*ih);
			}else{
				double ratio = 1.0;
				if(w/(double)iw > h/(double)ih){
					ratio = h/(double)ih;
				}else{
					ratio = w/(double)iw;
				}
				bw = (int)(ratio*iw);
				bh = (int)(ratio*ih);
				
			}
			g.setColor(Color.lightGray);
			g.fillRect(0,0,w,h);
			g.drawImage(bi,(w-bw)/2,(h-bh)/2,bw,bh,null);
			//g.drawImage(bi,0,0,null);
		}
		
		
		
	}
	public static void main(String[] args){
		JFrame jf = new JFrame("TEST");
		ImagePreviewPanel ip = new ImagePreviewPanel();
		jf.getContentPane().add(ip);
		jf.pack();
		jf.setVisible(true);
		ip.setImage(new File("test.png"));
	}
	
	
}