import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;
import java.util.regex.*;
import java.io.File;
import javax.swing.filechooser.FileNameExtensionFilter;
public class PagePropertyPanel extends JPanel implements ActionListener{
	JTextField filePathField = new JTextField(12);
	JTextField bookmarkField = new JTextField(12);
	JTextField groupField = new JTextField(12);
	JRadioButton bookmarkRadio = new JRadioButton("Bookmark");
	JRadioButton fileRadio = new JRadioButton("Image");
	JRadioButton groupRadio = new JRadioButton("Group");
	JButton ok = new JButton("OK");
	JButton cancel = new JButton("CANCEL");
	JButton selectFile = new JButton("FILE");
	String separater = ">";
	String defaultState = "FILEPATH=none";
	String currentDir = "./";
	String updateObjectId = "";
	PagePropertyPanel(){
		this.setLayout(new GridLayout(4,1));
		JPanel fp = new JPanel();
		fp.setLayout(new FlowLayout(FlowLayout.LEFT));
		fp.add(fileRadio);
		fp.add(filePathField);
		selectFile.setMargin(new Insets(0,0,0,0));
		selectFile.setFont(new Font("Gothic",Font.BOLD,10));
		selectFile.addActionListener(this);
		fp.add(selectFile);
		this.add(fp);
		
		fileRadio.setPreferredSize(new Dimension(100,24));
		bookmarkRadio.setPreferredSize(new Dimension(100,24));
		groupRadio.setPreferredSize(new Dimension(100,24));
		ButtonGroup gp = new ButtonGroup();
		gp.add(fileRadio);
		gp.add(bookmarkRadio);
		gp.add(groupRadio);
		fileRadio.addActionListener(this);
		bookmarkRadio.addActionListener(this);
		groupRadio.addActionListener(this);
		
		
		
		JPanel bp = new JPanel();
		bp.setLayout(new FlowLayout(FlowLayout.LEFT));
		bp.add(bookmarkRadio);
		bp.add(bookmarkField);
		this.add(bp);
		
		JPanel ggp = new JPanel();
		ggp.setLayout(new FlowLayout(FlowLayout.LEFT));
		ggp.add(groupRadio);
		ggp.add(groupField);
		this.add(ggp);
		
		JPanel btp = new JPanel();
		btp.setLayout(new GridLayout(1,2));
		btp.add(ok);
		btp.add(cancel);
		//cancel.addActionListener(this);
		this.add(btp);
		
		SimplePopupForJTextComponent spp = new SimplePopupForJTextComponent(bookmarkField);//Pass the instance at constructor.
		spp.setHistoryMax(100);//Change stock size of undoable events.(default:10)
		spp.setURAccelerator();//Set key accelerator for undo(CTRL+Z) redo(CTRL+SHIFT+Z).
		
		SimplePopupForJTextComponent spp2 = new SimplePopupForJTextComponent(groupField);//Pass the instance at constructor.
		spp2.setHistoryMax(100);//Change stock size of undoable events.(default:10)
		spp2.setURAccelerator();//Set key accelerator for undo(CTRL+Z) redo(CTRL+SHIFT+Z).
		
		SimplePopupForJTextComponent spp3 = new SimplePopupForJTextComponent(filePathField);//Pass the instance at constructor.
		spp3.setHistoryMax(100);//Change stock size of undoable events.(default:10)
		spp3.setURAccelerator();//Set key accelerator for undo(CTRL+Z) redo(CTRL+SHIFT+Z).
		
				
		fileRadio.doClick();
	}
	
	public void setData(String str){
		setData(str,"");
	}
	public void formatPanel(){
		
		bookmarkRadio.setEnabled(true);
		fileRadio.setEnabled(true);
		groupRadio.setEnabled(true);
		filePathField.setText("");
		bookmarkField.setText("");
		groupField.setText("");
		fileRadio.doClick();
	}
	public void setData(String str, String id){
		Hashtable<String,String> data = interpret(str);
		updateObjectId = id;
		//System.out.println(str);
		if(data.get("FILEPATH") != null){
			fileRadio.doClick();
		}else if(data.get("BOOKMARK") != null){
			bookmarkRadio.doClick();
		}else if(data.get("GROUP") != null){
			groupRadio.doClick();
		}
		
		bookmarkRadio.setEnabled(false);
		fileRadio.setEnabled(false);
		groupRadio.setEnabled(false);
		if(data.get("FILEPATH") != null){
			
			fileRadio.setEnabled(true);
			fileRadio.doClick();
			
			filePathField.setText(data.get("FILEPATH"));
		}else if(data.get("BOOKMARK") != null){
			bookmarkRadio.setEnabled(true);
			bookmarkRadio.doClick();
			bookmarkField.setText(data.get("BOOKMARK"));
		}else if(data.get("GROUP") != null){
			groupRadio.setEnabled(true);
			groupRadio.doClick();
			groupField.setText(data.get("GROUP"));
		}
	}
	public Hashtable<String,String> interpret(String str){
		String ar[] = str.split(separater);
		Pattern pat = Pattern.compile("([^=]+)=(.+)");
		Hashtable<String,String> ret = new Hashtable<String,String>();
		for(int ii = 0;ii < ar.length;ii++){
			Matcher mat = pat.matcher(ar[ii]);
			if(mat.find()){
				String k = mat.group(1).toUpperCase();
				String v = mat.group(2);
				ret.put(k,v);
			}
		}
		return ret;
	}
	public void setCurrentDir(String str){
		currentDir = str;
	}
	public void setObjectId(String i){
		updateObjectId = i;
	}
	public String getPropertyString(){
		StringBuffer sb = new StringBuffer();
		if(updateObjectId.length() > 0){
			sb.append("UPDATE=");
			sb.append(":::");
			sb.append(updateObjectId);
			sb.append(":::");
			if(fileRadio.isSelected()){
				sb.append(filePathField.getText());
			}else if(bookmarkRadio.isSelected()){
				sb.append(bookmarkField.getText());
			}else{
				sb.append(groupField.getText());
			}
		}else{
			if(fileRadio.isSelected()){
				sb.append("FILEPATH=");
				sb.append(filePathField.getText().replaceAll(":::",":::FILEPATH=").replaceAll(":::FILEPATH=$",""));
			}else if(bookmarkRadio.isSelected()){
				sb.append("BOOKMARK=");
				sb.append(bookmarkField.getText());
			}else{
				sb.append("GROUP=");
				sb.append(groupField.getText());
			}
		}
		return sb.toString();
	}
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == fileRadio || e.getSource() == bookmarkRadio || e.getSource() == groupRadio){
			if(fileRadio.isSelected()){
				bookmarkField.setEnabled(false);
				groupField.setEnabled(false);
				filePathField.setEnabled(true);
			}else if(bookmarkRadio.isSelected()){
				bookmarkField.setEnabled(true);
				groupField.setEnabled(false);
				filePathField.setEnabled(false);
			}else{
				
				bookmarkField.setEnabled(false);
				groupField.setEnabled(true);
				filePathField.setEnabled(false);
			}
		}
		
		if(e.getSource() == selectFile){
			
			loadFromFile();
		}
		/*if(e.getSource() == cancel){
			setData(defaultState);
		}*/
		
		
	}
	
	public void loadFromFile(){
		JFileChooser fc = new JFileChooser(currentDir);
		FileNameExtensionFilter filter = new FileNameExtensionFilter("Image(jpg, gif, png, bmp)", "jpg", "gif", "png", "bmp");
    		fc.setFileFilter(filter);

		
		
		
		StringBuffer sb = new StringBuffer();
		fc.setMultiSelectionEnabled(updateObjectId.length() < 1);
		int selected = fc.showOpenDialog(this);
		if(selected == JFileChooser.APPROVE_OPTION){
			if(updateObjectId.length() < 1){
				File[] fl = fc.getSelectedFiles();
				for(int ii = 0;ii<fl.length;ii++){
					sb.append(fl[ii].getPath()+":::");
				}
			}else{
				File fl = fc.getSelectedFile();
				
				sb.append(fl.getPath()+":::");
				
			}
		}
		filePathField.setText(sb.toString());
	}
	public static void main(String[] args){
		JFrame frame = new JFrame("test");
		
        frame.setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
        frame.getContentPane().add(new PagePropertyPanel());
        frame.pack();
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
		
	}
	
}