import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.image.*;
import javax.imageio.*;
import java.util.*;
import java.util.regex.Pattern;
import java.util.regex.Matcher;
import java.io.*;
import java.nio.channels.FileChannel;
import javax.imageio.stream.ImageOutputStream; 
import java.awt.color.*;
import java.util.zip.*;
public class PankuzuCompilerPanel extends JPanel implements ActionListener{
	public static String SEPARATER_B = PPMainPanel.SEPARATER_B;
	public static String SEPARATER_A = PPMainPanel.SEPARATER_A;
	
	public static final int EVENTCODE_COMPILE = PPMainPanel.EVENTCODE_COMPILE;
	public static final int COMPILE_NORMALZIP = PPMainPanel.COMPILE_NORMALZIP;
	public static final int COMPILE_ANDROBOOKZIP = PPMainPanel.COMPILE_ANDROBOOKZIP;
	public static final int COMPILE_PDF = PPMainPanel.COMPILE_PDF;
	public static final int COMPILE_EPUB = PPMainPanel.COMPILE_EPUB;
	
	
	
	
	public static final int EVENT_NORMALZIP = 0;
	public static final int EVENT_ANDROBOOKZIP = 1;
	public static final int EVENT_PDF = 2;
	public static final int EVENT_EPUB = 3;
	
	
	
	public static final int JBUTTON_NORMALZIP = 0;
	public static final int JBUTTON_ANDROBOOKZIP = 1;
	public static final int JBUTTON_PDF = 2;
	public static final int JBUTTON_EPUB = 3;
	public static String JBUTTON__NAME[] = {"ZIP(Normal)","ZIP(Numbered Jpeg)","PDF","EPUB"};
	public static final int[] JBUTTON__EVENT ={EVENT_NORMALZIP,EVENT_ANDROBOOKZIP,EVENT_PDF,EVENT_EPUB};
	JButton jButton[];
	Hashtable<Object,Integer> eventObjectHash = new Hashtable<Object,Integer>();
	ActionListener parentListener = null;
	boolean cancelPressed = false;
	PankuzuZipper pzip = new PankuzuZipper();
	String progressString = "";
	javax.swing.JLabel progressLabel = null;
	PankuzuCompilerPanel(){
		this.setLayout(new GridLayout(JBUTTON__NAME.length,0));
		jButton = new JButton[JBUTTON__NAME.length];
		for(int ii = 1;ii < JBUTTON__NAME.length;ii++){
			jButton[ii] = new JButton(JBUTTON__NAME[ii]);
			jButton[ii].addActionListener(this);
			eventObjectHash.put(jButton[ii],JBUTTON__EVENT[ii]);
			this.add(jButton[ii]);
		}
	}
	
	public static void setInterpretationString(Hashtable<String,Integer> s){
		s.put("COMPILE",EVENTCODE_COMPILE);
	}
	
	public void actionPerformed(ActionEvent e){
		if(eventObjectHash.get(e.getSource()) != null){
			StringBuffer actionstringbuffer = new StringBuffer();
			switch(eventObjectHash.get(e.getSource())){
				case EVENT_NORMALZIP:
				actionstringbuffer.append("ACTION=COMPILE"+SEPARATER_B+"TYPE="+String.valueOf(COMPILE_NORMALZIP));
				break;
				case EVENT_ANDROBOOKZIP:
					
				actionstringbuffer.append("ACTION=COMPILE"+SEPARATER_B+"TYPE="+String.valueOf(COMPILE_ANDROBOOKZIP));
					
				break;
				case EVENT_PDF:
				
				actionstringbuffer.append("ACTION=COMPILE"+SEPARATER_B+"TYPE="+String.valueOf(COMPILE_PDF));
				break;
				case EVENT_EPUB:
				
				actionstringbuffer.append("ACTION=COMPILE"+SEPARATER_B+"TYPE="+String.valueOf(COMPILE_EPUB));
				break;
			}
			if(parentListener != null && actionstringbuffer.length() > 5){
				parentListener.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,actionstringbuffer.toString()));
			}
		}
	}
	public String getProgressString(){
		return progressString;
	}
	public void setProgressLabel(JLabel jl){
		progressLabel = jl;
	}
	public void setProgressString(String px){
		if(progressLabel != null){
			progressLabel.setText(px);
			progressLabel.repaint();
		}
		progressString = px;
	}
	public void cancel(){
		cancelPressed = true;
		pzip.cancel();
	}
	public void reactivateCancel(){
		cancelPressed = false;
		pzip.reactivateCancel();
	}
	public static File makeRandomDir(){
		String ret = "__tmp__";
		File f = new File(ret);
		while(f.exists()){
			ret = "__tmp__"+String.valueOf(Math.random()).replaceAll("[^0-9]","");
			f = new File(ret);
		}
		f.mkdir();
		return f;
	}
	public void makeAndroBookZip(String outname,ArrayList<File> al){
		ArrayList<File> fname = new ArrayList<File>();
		ArrayList<String> ename = new ArrayList<String>();
		File tmpdir = makeRandomDir();
		int fnum = 0;
		reactivateCancel();
		for(int ii = 0;ii < al.size();ii++){
			File f = al.get(ii);
			String name = f.getName();
			name = name.replace("\\.[^.]+$","");
			String entname = String.format("p%07d.jpg",fnum);
			String ext = getExtensionCode(f).toLowerCase();
			if(ext.equals("jpg") || ext.equals("jpeg")){
				fname.add(f);
				ename.add(entname);
				fnum++;
			}else{
				boolean bool = copy(f,new File(tmpdir.getPath()+"/"+name+".jpg"),true);
				if(bool){
					fname.add(new File(tmpdir.getPath()+"/"+name+".jpg"));
					ename.add(entname);
					fnum++;
				}
			}
		}
		pzip.zip(outname,fname,ename);
		
		deleteFiles(tmpdir);
	}
	public void makeAndroBookHTMLZip(ArrayList<File> al){
		
	}
	public static void copyAll(ArrayList<File> al,File outdir,boolean chkimage,boolean converttojpeg){
		String path_dir = outdir.getPath()+"/";
		if(!outdir.exists()){
			try{
			outdir.mkdir();
			}catch(Exception exx){
				ErrorMessageBox.append(exx.getMessage());
				return ;
			}
		}
		for(int ii = 0;ii < al.size();ii++){
			String outfilename = al.get(ii).getName();
			if(converttojpeg){
				outfilename = outfilename.replaceAll("\\.[^.]+$","")+".jpg";
			}
			String outname = path_dir+outfilename;
			try{
				copy(al.get(ii),new File(outname),chkimage);
			}catch(Exception exx){
				ErrorMessageBox.append(exx.getMessage());
			}
		}
		
	}
	public void setParentListener(ActionListener ac){
		parentListener = ac;
	}
	public static boolean copy(File in,File out,boolean chkimage){
		
		String outext = getExtensionCode(out).toLowerCase();
		String inext = getExtensionCode(in).toLowerCase();
		
		if(outext.equals("jpeg")){
			outext = "jpg";
		}
		if(inext.equals("jpeg")){
			inext = "jpg";
		}
		
		if(!chkimage && outext.equals(inext)){
			FileChannel src = null;
			FileChannel dest = null;
			
			try{
				src = new FileInputStream(in).getChannel();
				dest = new FileOutputStream(out).getChannel();
				
				src.transferTo(0, src.size(),dest);
				
				src.close();
				dest.close();
				return true;
			}catch(Exception exx){
				ErrorMessageBox.append(exx.getMessage());
			}
			try{
				
				src.close();
				dest.close();
				
			}catch(Exception exx){
				ErrorMessageBox.append(exx.getMessage());
				
			}
			
		}else{
			try{
				BufferedImage src = ImageIO.read(in);
				
				
				if(outext.equals(inext)){
					boolean result = ImageIO.write(src,outext,out);
					
					if(!result){
							ErrorMessageBox.append("Could not copy image "+in.getPath()+" > "+out.getPath());
					}
				}else{
					convertTo(src,out);
				}
				
			
				return true;
			}catch(Exception exx){
				ErrorMessageBox.append(exx.getMessage());
			}
			
		}
		return false;
		
	}
	
	public static void deleteFiles(File f){
		if(!f.exists()){
			return ;
		}
		
		if(f.isFile()){
			try{
				boolean p = f.delete();
				if(!p){
					f.deleteOnExit();
				}
			}catch(Exception exx){
				
				ErrorMessageBox.append(exx.getMessage());
			}
		}else if(f.isDirectory()){
			File[] files=f.listFiles();
			for(int ii=0; ii<files.length; ii++){
				deleteFiles( files[ii] );
			}
			try{
				boolean p = f.delete();
				if(!p){
					f.deleteOnExit();
				}
			}catch(Exception exx){
				
				ErrorMessageBox.append(exx.getMessage());
			}
		}
	}

	public static void convertTo(BufferedImage image, File out) {
		String ext = getExtensionCode(out).toLowerCase();
        Iterator writers = ImageIO.getImageWritersBySuffix(ext);
        if (writers.hasNext()) {
            ImageWriter writer = (ImageWriter)writers.next();
            try {
				if((ext.equals("jpg") || ext.equals("jpeg") || ext.equals("bmp"))
				 &&( image.getType() == BufferedImage.TYPE_INT_ARGB
				|| image.getType() == BufferedImage.TYPE_INT_ARGB_PRE
				|| image.getType() == BufferedImage.TYPE_4BYTE_ABGR_PRE 
				|| image.getType() == BufferedImage.TYPE_4BYTE_ABGR
				|| image.getType() == BufferedImage.TYPE_CUSTOM)){
					BufferedImage newimg = new BufferedImage(image.getWidth(),image.getHeight(),BufferedImage.TYPE_INT_RGB);
					Graphics g = newimg.createGraphics();
					g.drawImage(image,0,0,null);
					/*
					ColorConvertOp colorConvert = new ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_sRGB  ), null);
					image = colorConvert.filter(image, null);
					*/
					image=newimg;
				}

				
                ImageOutputStream stream = ImageIO.createImageOutputStream(out);
                writer.setOutput(stream);

                ImageWriteParam param = writer.getDefaultWriteParam();
                if (param.canWriteCompressed()) {
                    param.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
                    param.setCompressionQuality(0.95f);
                }
                writer.write(null, new IIOImage(image, null, null), param);
                writer.dispose();
				stream.close();
            } catch (Exception exx) {
                ErrorMessageBox.append(exx.getMessage());
            }
           writer.dispose();
        }else{
                ErrorMessageBox.append("Fileformat error! "+out.getPath());
        }
    }
	public static String getExtensionCode(File f){
		return getExtensionCode(f.getPath());
	}
	
	
	public void zip(String outfilename,ArrayList<File> farray,ArrayList<String> entryarray) {
		File zip =  new File(outfilename);
		PankuzuZipper pz  = new PankuzuZipper();
		try {
		    ZipOutputStream out = new ZipOutputStream(new FileOutputStream(zip));
			out.setLevel(0);
			for(int ii = 0;ii < farray.size();ii++){
				String en;
				File f = farray.get(ii);
					if(ii >= entryarray.size()){
						en = String.valueOf(ii)+f.getName();
					}else{
						en = entryarray.get(ii);
					}
			    	//System.out.println(en);
				pz.appendFile(out,f,en);
					if(cancelPressed){
						out.close();
						return;
						
					}

			}
			out.close();
		} catch (Exception exx) {
		    exx.printStackTrace();
		}
	}
	public static String getExtensionCode(String f){
		Pattern pat = Pattern.compile("\\.([^.]+)$");
		Matcher mat = pat.matcher(f);
		if(mat.find()){
			return mat.group(1);
		}
		return "";
	}
	public static void main(String[] args){
		
		
		JFrame jf = new JFrame();
		PankuzuCompilerPanel pz = new PankuzuCompilerPanel();
		jf.getContentPane().add(pz);
		
		jf.pack();
		jf.setVisible(true);
		
		
		/*
		PankuzuCompilerPanel pc = new PankuzuCompilerPanel();
		pc.copy(new File("testc.png"),new File("testc2.jpg"),true);
		ArrayList<File> al = new ArrayList<File>();
		al.add(new File("testc.png"));
		al.add(new File("testc2.jpg"));
		al.add(new File("790_0.png"));
		
		pc.makeAndroBookZip("testzip.zip",al);
		System.out.println(ErrorMessageBox.getString());
		*/
	}
}