import java.io.*;
import java.util.*;
import java.util.regex.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import javax.swing.text.*;
import javax.swing.undo.*;


public class SimplePopupForJTextComponent extends JPopupMenu implements MouseListener,ActionListener,UndoableEditListener,KeyListener{
/*
Copyright (c) 2008,sesamecake
All rights reserved.

Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following conditions are met:
    * Redistributions of source code must retain the above copyright notice, this list of conditions and the following disclaimer.
    * Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following disclaimer in the documentation and/or other materials provided with the distribution.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*/

/*
NORMAL USEAGE

JTextArea jt = new JTextArea();//any component(Is think) extending JTextComponent.
SimplePopupForJTextComponent spp = new SimplePopupForJTextComponent(jt);//Pass the instance at constructor.

//optional
spp.setHistoryMax(100);//Change stock size of undoable events.(default:10)
spp.setURAccelerator();//Set key accelerator for undo(CTRL+Z) redo(CTRL+SHIFT+Z).


*/
	public static final int EVENT_CUT = 0;
	public static final int EVENT_COPY = 1;
	public static final int EVENT_PASTE = 2;
	public static final int EVENT_DELETE = 3;
	public static final int EVENT_SELECTALL= 4;
	public static final int EVENT_UNDO = 8;
	public static final int EVENT_REDO = 9;
	
	
	public static final int JMENUITEMPOP_UNDO = 0;
	public static final int JMENUITEMPOP_REDO = 1;
	public static final int JMENUITEMPOP_SEP1 = 2;
	public static final int JMENUITEMPOP_CUT = 3;
	public static final int JMENUITEMPOP_COPY = 4;
	public static final int JMENUITEMPOP_PASTE = 5;
	public static final int JMENUITEMPOP_DELETE = 6;
	public static final int JMENUITEMPOP_SEP2 = 7;
	public static final int JMENUITEMPOP_SELECTALL = 8;
	public static final String[] JMENUITEMPOP__NAME = {"Undo","Redo","sep","Cut","Copy","Paste","Delete","sep","SelectAll"};
	public static final int[] JMENUITEMPOP__EVENT ={EVENT_UNDO,EVENT_REDO,-1,EVENT_CUT,EVENT_COPY,EVENT_PASTE,EVENT_DELETE,-1,EVENT_SELECTALL};
	
	
	
	JMenuItem[] jMenuItemPop;
	JTextComponent parentComponent = null;
	ArrayList<UndoableEdit> historyArray = new ArrayList<UndoableEdit>();
	int historyMax = 10;
	int historyIndex = -1;
	Hashtable<Object,Integer> eventObjectHash = new Hashtable<Object,Integer>();
	
	SimplePopupForJTextComponent(JTextComponent jt){
		parentComponent = jt;
		parentComponent.addMouseListener(this);
		parentComponent.getDocument().addUndoableEditListener(this);
		
		
		jMenuItemPop = new JMenuItem[JMENUITEMPOP__NAME.length];
		for(int ii = 0;ii < JMENUITEMPOP__NAME.length;ii++){
			if(JMENUITEMPOP__NAME[ii].compareTo("sep") != 0){
				
				jMenuItemPop[ii] = new JMenuItem(JMENUITEMPOP__NAME[ii]);
				this.add(jMenuItemPop[ii]);
				jMenuItemPop[ii].addActionListener(this);
				if(JMENUITEMPOP__EVENT[ii] > -1){
					eventObjectHash.put(jMenuItemPop[ii],JMENUITEMPOP__EVENT[ii]);
				}
			}else{
				this.addSeparator();
			}
		}
		
	}
	public void setHistoryMax(int i){
		historyMax = i;
	}
	public void setURAccelerator(){
		//jMenuItemPop[JMENUITEMPOP_UNDO].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_DOWN_MASK));
		//jMenuItemPop[JMENUITEMPOP_REDO].setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,InputEvent.CTRL_DOWN_MASK+InputEvent.SHIFT_DOWN_MASK));
		parentComponent.addKeyListener(this);
	}
		
	public void undoableEditHappened(UndoableEditEvent e){
		if(historyIndex > -1){
			for(int ii = -1;ii < historyIndex;ii++){
				historyArray.remove(0);
			}
		}
		historyArray.add(0,e.getEdit());
		while(historyArray.size() > historyMax){
			historyArray.remove(historyArray.size()-1);
		}
		historyIndex = -1;
	}
	public void mouseEntered(MouseEvent e){
		
	}
	public void mouseExited(MouseEvent e){
		
	}
	public void mousePressed(MouseEvent e){
		if (e.isMetaDown()) {
			if(e.getSource() == parentComponent){
				parentComponent.requestFocusInWindow();
				this.show(e.getComponent(), e.getX(), e.getY());
			}
			
		}
	}
	public void mouseClicked(MouseEvent e){
		
	}
	public void mouseReleased(MouseEvent e){
		
	}
	public void keyPressed(KeyEvent e){
		if(e.isControlDown() && e.getKeyCode() == KeyEvent.VK_Z){
			if(e.isShiftDown()){
				jMenuItemPop[JMENUITEMPOP_REDO].doClick();
			}else{
				jMenuItemPop[JMENUITEMPOP_UNDO].doClick();
			}
		}else if(e.isControlDown() && e.getKeyCode() == KeyEvent.VK_Y){
			jMenuItemPop[JMENUITEMPOP_REDO].doClick();
			
		}
	}
	public void keyTyped(KeyEvent e){
	}
	public void keyReleased(KeyEvent e){
	}
	
	public void actionPerformed(ActionEvent e){
		if(eventObjectHash.get(e.getSource()) != null){
			switch(eventObjectHash.get(e.getSource())){
				case EVENT_CUT:
					parentComponent.cut();
				break;
				case EVENT_COPY:
					parentComponent.copy();
				break;
				case EVENT_PASTE:
					parentComponent.paste();
				break;
				case EVENT_DELETE:
					parentComponent.replaceSelection("");
				break;
				case EVENT_SELECTALL:
					parentComponent.selectAll();
				break;
				
				case EVENT_UNDO:{
					if(historyIndex < historyArray.size() -1){
						historyIndex++;
						historyArray.get(historyIndex).undo();
					}
				}break;
				case EVENT_REDO:{
					if(historyIndex > -1){
						historyArray.get(historyIndex).redo();
						historyIndex--;
					}
				}break;
			}
		}
	}
}